%test the anisotropic mesh adaptation

%create square mesh
L=1; %in m
nx=70; %numberof nodes in x direction
ny=70;
md=model;

%mesh adaptation loop YAMS
md=squaremesh(md,L,L,nx,ny);
plotmodel(md,'data','mesh');pause(0.5);
for i=1:1
	u=4*md.x-2; v=4*md.y-2;
	md.vel_obs=tanh(30*(u.^2+v.^2-0.25)) ...
		+tanh(30*((u-0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u-0.75).^2+(v+0.75).^2-0.25)) ...
		+tanh(30*((u+0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u+0.75).^2+(v+0.75).^2-0.25)) ;
	md=YamsCall(md,md.vel_obs,0.005,0.3,1.3,10^-4);
	plotmodel(md,'data','mesh');pause(0.5);
end
for i=1:1
	u=4*md.x-2; v=4*md.y-2;
	md.vel_obs=tanh(30*(u.^2+v.^2-0.25)) ...
		+tanh(30*((u-0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u-0.75).^2+(v+0.75).^2-0.25)) ...
		+tanh(30*((u+0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u+0.75).^2+(v+0.75).^2-0.25)) ;
	md=YamsCall(md,md.vel_obs,0.005,0.3,2,10^-4);
	plotmodel(md,'data','mesh');pause(0.5);
end
for i=1:3,
	u=4*md.x-2; v=4*md.y-2;
	md.vel_obs=tanh(30*(u.^2+v.^2-0.25)) ...
		+tanh(30*((u-0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u-0.75).^2+(v+0.75).^2-0.25)) ...
		+tanh(30*((u+0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u+0.75).^2+(v+0.75).^2-0.25)) ;
	md=YamsCall(md,md.vel_obs,0.005,0.3,2,0.001);
	plotmodel(md,'data','mesh');pause(0.5);
end
md.vel_obs=tanh(30*((4*md.x-2).^2+(4*md.y-2).^2-0.25))+...
	tanh(30*((4*md.x-2.75).^2+(4*md.y-1.25).^2-2.75))+...
	tanh(30*((4*md.x-2.75).^2+(4*md.y-2).^2-1.25))+...
	tanh(30*((4*md.x-1.25).^2+(4*md.y-2).^2-2.75))+...
	tanh(30*((4*md.x-1.25).^2+(4*md.y-2).^2-1.25));

%mesh adaptation loop BAMG
md=squaremesh(md,L,L,nx,ny);
plotmodel(md,'data','mesh');pause(0.5);
for i=1:1
	u=4*md.x-2; v=4*md.y-2;
	md.vel_obs=tanh(30*(u.^2+v.^2-0.25)) ...
		+tanh(30*((u-0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u-0.75).^2+(v+0.75).^2-0.25)) ...
		+tanh(30*((u+0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u+0.75).^2+(v+0.75).^2-0.25)) ;
	md.bamg=NaN;
	md=bamg(md,'field',md.vel_obs,'hmin',0.005,'hmax',0.3,'gradation',1.3,'err',10^-4);
	plotmodel(md,'data','mesh');pause(0.5);
end
for i=1:1
	u=4*md.x-2; v=4*md.y-2;
	md.vel_obs=tanh(30*(u.^2+v.^2-0.25)) ...
		+tanh(30*((u-0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u-0.75).^2+(v+0.75).^2-0.25)) ...
		+tanh(30*((u+0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u+0.75).^2+(v+0.75).^2-0.25)) ;
	md.bamg=NaN;
	md=bamg(md,'field',md.vel_obs,'hmin',0.005,'hmax',0.3,'gradation',2,'err',10^-4);
	plotmodel(md,'data','mesh');pause(0.5);
end
for i=1:3,
	u=4*md.x-2; v=4*md.y-2;
	md.vel_obs=tanh(30*(u.^2+v.^2-0.25)) ...
		+tanh(30*((u-0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u-0.75).^2+(v+0.75).^2-0.25)) ...
		+tanh(30*((u+0.75).^2+(v-0.75).^2-0.25)) +tanh(30*((u+0.75).^2+(v+0.75).^2-0.25)) ;
	md.bamg=NaN;
	md=bamg(md,'field',md.vel_obs,'hmin',0.001,'hmax',0.3,'gradation',2,'err',10^-3);
	plotmodel(md,'data','mesh');pause(0.5);
end
md.vel_obs=tanh(30*((4*md.x-2).^2+(4*md.y-2).^2-0.25))+...
	tanh(30*((4*md.x-2.75).^2+(4*md.y-1.25).^2-2.75))+...
	tanh(30*((4*md.x-2.75).^2+(4*md.y-2).^2-1.25))+...
	tanh(30*((4*md.x-1.25).^2+(4*md.y-2).^2-2.75))+...
	tanh(30*((4*md.x-1.25).^2+(4*md.y-2).^2-1.25));
